#Fengyun 2H Cloud Classification Product import routine
#use is made of awx - python plugin (https://github.com/wqshen/AwxReader/blob/master/README.md)

       
from tkinter import *
from tkinter.filedialog import askdirectory
from tkinter.filedialog import askopenfilename
from tkinter.ttk import Progressbar, Style
import os
import ilwis
import numpy as np
import subprocess
import shutil
import glob
import gzip
import zipfile
from threading import Thread
from awx import Awx

#passing parameters from sub menu

def execute(GNCDir, InFileName, WorkDir, OutFileName):
    if len(GNCDir) > 0 and len(InFileName) > 0 and len(WorkDir) > 0 and len(OutFileName) > 0:

        progress['value'] = 0
        time_stamp_in = InFileName
        timeA = time_stamp_in[:8]
        timeB = time_stamp_in[8:12]
                
        os.chdir(WorkDir)
        ilwis.setWorkingCatalog(WorkDir)
        
        #filename = Z_SATE_C_BABJ_20250425220000_O_FY2H_CLT_MLT_001_NOM.AWX.gz 
        for filename in glob.glob(os.path.join(GNCDir+'/Z_SATE_C_BABJ_'+(InFileName)+'00_O_FY2H_CLT_MLT_001_NOM.AWX.gz')):
            #print(filename)
            shutil.copy(filename, WorkDir)

        progress['value'] = 20  

        for fnames in glob.glob(os.path.join(WorkDir+'/Z_SATE_C_BABJ_'+(InFileName)+'00_O_FY2H_CLT_MLT_001_NOM.AWX.gz')):
            file_in = fnames

        def extract_gz(file_path, output_path):
            with gzip.open(file_path, 'rb') as f_in:
                with open(output_path, 'wb') as f_out:
                    shutil.copyfileobj(f_in, f_out)
                    
        #Extracting file
        extract_gz(WorkDir+'/Z_SATE_C_BABJ_'+(InFileName)+'00_O_FY2H_CLT_MLT_001_NOM.AWX.gz', WorkDir+'/cma_clc_rename_(timeA)_(timeB)_FY2H.AWX')            
            
      
        fname_new = 'cma_clc_rename_(timeA)_(timeB)_FY2H.AWX'
                
        progress['value'] = 40  
        
        ds = Awx(WorkDir+'/'+fname_new)
        
        clt = ds.values
        array_2d = np.squeeze(clt) # Remove the first dimension (squeeze it)

        progress['value'] = 60 

        d_out = array_2d.values
        
        grf = ilwis.GeoReference('code=georef:type=corners, csy=epsg:4326, envelope=30 55 130 -45, gridsize=1001 1001, cornerofcorners=yes')
        dfNum = ilwis.DataDefinition(ilwis.NumericDomain('code=value'), ilwis.NumericRange(0, 100, 0))
        rcNew = ilwis.RasterCoverage()
        rcNew.setSize(ilwis.Size(1001,1001,1))
        rcNew.setGeoReference(grf)
        rcNew.setDataDef(dfNum)
        
        
        progress['value'] = 80
        
        rcNew.array2raster(d_out)
        rcNew.store(OutFileName+'_val.mpr')
        
        # create a new NumericItemRange and fill it with required class items
        cltrange = ilwis.NumericItemRange()
        cltrange.add(('Clear Oceans', 0.0, 0.99)) #0
        cltrange.add(('Clear Lands', 1.0, 1.99)) #1
        cltrange.add(('Mixed Pixels', 11.0, 11.99)) #11
        cltrange.add(('Altostratus or Nimbostratus', 12.0, 12.99)) #12
        cltrange.add(('Cirrostratus', 13.0, 13.99)) #13
        cltrange.add(('Cirrus dense', 14.0, 14.99)) #14
        cltrange.add(('Cumulonimbus', 15.0, 15.99)) #15
        cltrange.add(('Stratoculumlus or Altocumulus', 21.0, 21.99)) #21

        #assign the range to a new ItemDomain
        clt_dom = ilwis.ItemDomain(cltrange)
        
        cloud_cl = ilwis.do('sliceraster', rcNew, clt_dom)
        
        cloud_cl.datadef().domain().name(OutFileName+'_cl') 
        
        cloud_cl.store(OutFileName+'_cl.mpr')
        
        for filename in glob.glob(os.path.join(gnc_path+'/extern/ilwis386_2system/FY_clt_outClass.rp*')):
            #print(filename)
            shutil.copy(filename, WorkDir)  
        
        os.replace(WorkDir+'/FY_clt_outClass.rpr', WorkDir+'/'+OutFileName+'_cl.rpr')
        os.replace(WorkDir+'/FY_clt_outClass.rp#', WorkDir+'/'+OutFileName+'_cl.rp#')


        #input file
        fin = open(WorkDir+'/'+OutFileName+'_cl.rpr', 'rt')
        #output file to write the result to
        fout = open(WorkDir+'/temp.rpr', 'wt')
        #for each line in the input file
        for line in fin:
            #read replace the string and write to output file
            fout.write(line.replace('FY_clt_outClass', OutFileName+'_cl'))
        #close input and output files
        fin.close()
        fout.close()

        #remove file
        if os.path.exists(WorkDir+'/'+OutFileName+'_cl.rpr'):
            os.remove(WorkDir+'/'+OutFileName+'_cl.rpr')
        #else:
        #    print("The file does not exist")


        old_name = WorkDir+'/temp.rpr'
        new_name = WorkDir+'/'+OutFileName+'_cl.rpr'
        # Renaming the file
        os.rename(old_name, new_name)

        
        
        os.rename(WorkDir+'/'+fname_new,WorkDir+'/Z_SATE_C_BABJ_'+(InFileName)+'00_O_FY2H_CLT_MLT_001_NOM.AWX')

        progress['value'] = 100
        
        button0.config(state='normal')
        button1.config(state='normal')

#redundant files deleted in main menu script

def executeInThread(GNCDir, InFileName, WorkDir, OutFileName):
    button0.config(state='disabled')
    button1.config(state='disabled')
    thread = Thread(target = execute, args = (GNCDir, InFileName, WorkDir, OutFileName))
    thread.start()



# for command=doNothing
def doNothing():
   text="Do nothing button"
   return


# for command=clickthumbn
def clickthumbn():
   novi = Toplevel(app)
   novi.title ('Example of imported FY2H - CLT image (in ILWIS)')
   novi.iconbitmap(gnc_path +r'/pics/gnc.ico')
   canvas = Canvas(novi, width = 400, height = 401)
   canvas.pack(expand = YES, fill = BOTH)
   gif1 = PhotoImage(file = gnc_path +r'/pics/FY2H_CLT.gif')
   canvas.create_image(0, 0,image = gif1, anchor = NW)
   canvas.gif1 = gif1

# for command=clickAbout
def clickAbout(): 
   filewin = Toplevel(app)
   filewin.title ('About FY2H - CLT')
   filewin.iconbitmap(gnc_path +r'/pics/gnc.ico')
   filewin.geometry("575x340")
   msg = Message(filewin, text="""FY2H CLT background:

FY2H derived cloud classification. Map consiting of maximum of 8 classes, classes identified are: 0: clear oceans, 1: clear lands, 11: mixed pixels, 12: altostratus or nimbostratus, 13: cirrostratus, 14: cirrus dense, 15: cumulonimbus, 21: stratocumulus or altocumulus.

File name convertion: Z_SATE_C_BABJ_20250425220000_O_FY2H_CLT_MLT_001_NOM.AWX.gz 
Number of segments: 1 body segment
Temporal Resolution: 1 hour
Initial file format: AWX

Data is provided throught EUMETCast reception. For Legal Constraints check the 'Product Navigator' at EUMETSAT available at http://navigator.eumetsat.int
""")
   msg.pack()


#main()
#automatically setting of path when running this script from main menu - uncomment to make active   
gnc_path = os.environ["gnc_popup"]

#check path
print (gnc_path)
app = Tk()
app.title("Fengyun 2H CLT import routine")
app.iconbitmap(gnc_path +r'/pics/gnc.ico')

w = 650 # width for the Tk app
h = 210 # height for the Tk app

app.geometry('%dx%d' % (w, h))
app.resizable(0,0)

labelText1 = StringVar()
labelText1.set ("""FY2H CLT
Typical filename: Z_SATE_C_BABJ_20250425220000_O_FY2H_CLT_MLT_001_NOM.AWX.gz""")

label1 = Label(app, textvariable=labelText1, anchor='w', justify = LEFT)
label1.pack(side = LEFT)
label1.place(x = 10, y = 5, width=650, height=35)

L1 = Label(app, text="Input Directory:", anchor='w')
L1.pack(side = LEFT)
L1.place(x = 10, y = 50, width=150, height=25)

inputDir = StringVar()
E1 = Entry(app, textvariable=inputDir, bd =2)
E1.pack()
E1.place(x = 165, y = 50, width=445, height=25)

button_dirin = Button(app, text="....", width=2, command = lambda: inputDir.set(askdirectory(initialdir = inputDir.get())))
button_dirin.pack()
button_dirin.place(x = 615, y = 49)

L2 = Label(app, text="Time Stamp (in UTC-time):", anchor='w')
L2.pack(side = LEFT)
L2.place(x = 10, y = 80, width=150, height=25)

inputFile = StringVar()
E2 = Entry(app, textvariable=inputFile, bd =2)
E2.pack()
E2.place(x = 165, y = 80, width=445, height=25)

#button_filein = Button(app, text="....", width=2, command = lambda: inputFile.set(askopenfilename(initialdir = inputDir.get()).split('/')[-1]))
#button_filein.pack()
#button_filein.place(x = 615, y = 79)

L3 = Label(app, text="Output Directory:", anchor='w')
L3.pack(side = LEFT)
L3.place(x = 10, y = 110, width=150, height=25)

outputDir = StringVar()
E3 = Entry(app, textvariable=outputDir, bd =2)
E3.pack()
E3.place(x = 165, y = 110, width=445, height=25)

button_dirout = Button(app, text="....", width=2, command = lambda: outputDir.set(askdirectory(initialdir = outputDir.get())))
button_dirout.pack()
button_dirout.place(x = 615, y = 109) 

L4 = Label(app, text="Output Filename:", anchor='w')
L4.pack(side = LEFT)
L4.place(x = 10, y = 140, width=150, height=25)

outputFile = StringVar()
E4 = Entry(app, textvariable=outputFile, bd =2)
E4.pack()
E4.place(x = 165, y = 140, width=445, height=25)

button0 = Button(app, text="Quit", width=15, command=app.destroy)
button0.pack()
button0.place(x = 525, y = 180)

button1 = Button(app, text="Execute", width=15, command=lambda: executeInThread(inputDir.get(), inputFile.get(), outputDir.get(), outputFile.get()))
button1.pack()
button1.place(x = 405, y = 180)

button2 = Button(app, text="About CLT", width=15, command=clickAbout)
button2.pack()
button2.place(x = 285, y = 180)

button3 = Button(app, text="Thumbnail", width=15, command=clickthumbn)
button3.pack()
button3.place(x = 165, y = 180)


style = Style()
style.theme_use('clam')
style.configure('blue.Horizontal.TProgressbar', foreground='blue', background='blue')

progress = Progressbar(app, style='blue.Horizontal.TProgressbar', orient=HORIZONTAL, length=100, mode='determinate')
progress.pack()
progress.place(x = 10, y = 180)


app.mainloop()

print("inputFile=" + inputFile.get())
print("outputDir=" + outputDir.get())
print("outputFile=" + outputFile.get())



