#MSG0 MPEF FIRC import routine
        
from tkinter import *
from tkinter.filedialog import askdirectory
from tkinter.filedialog import askopenfilename
from tkinter.ttk import Progressbar, Style
import shutil
import sys, os 
import glob
import subprocess
from threading import Thread
import numpy as np
import bz2

#passing parameters from sub menu

def execute(GNCDir, InFileName, WorkDir, OutFileName):
    if len(GNCDir) > 0 and len(InFileName) > 0 and len(WorkDir) > 0 and len(OutFileName) > 0:

        progress['value'] = 0
        time_stamp = InFileName
        
        os.chdir(WorkDir)
        
        progress['value'] = 20
        
        #input file = W_XX-EUMETSAT-Darmstadt,SING+LEV+SAT,MET10+FIRC_C_EUMG_20250123184500_3.txt
        for filename in glob.glob(os.path.join(GNCDir+'/W_XX-EUMETSAT-Darmstadt,SING+LEV+SAT,MET'+'*+FIRC_C_EUMG_'+str(time_stamp)+'00_*.txt')):
            shutil.copy(filename, WorkDir)
            
        for fnames in glob.glob(os.path.join(WorkDir+'/W_XX-EUMETSAT-Darmstadt,SING+LEV+SAT,MET'+'*+FIRC_C_EUMG_'+(time_stamp)+'00_*.txt')):
            file_in = fnames
            print(file_in)

        progress['value'] = 60
        
       
        progress['value'] = 60
        
        decode = subprocess.call(['javaw', '-jar', gnc_path+'/extern/FIRC_import/ConvertFIRCV2.jar', file_in])
        print(decode) #code 0 is indicating successful operation
        
        #rename default output filenames created by java application
        #W_XX-EUMETSAT-Darmstadt,SING+LEV+SAT,MET10+FIRC_C_EUMG_20250123191500_3Likely.csv
        #W_XX-EUMETSAT-Darmstadt,SING+LEV+SAT,MET10+FIRC_C_EUMG_20250123191500_3Possible.csv

        name_without_extension = os.path.splitext(fnames)[0]
        
        possible_filename = name_without_extension+'Possible.csv'
        new_filename = OutFileName+'_Possible.csv'

        # Rename the file
        os.rename(possible_filename, new_filename)
        
        likely_filename = name_without_extension+'Likely.csv'
        new_filename = OutFileName+'_Likely.csv'

        # Rename the file
        os.rename(likely_filename, new_filename)

        progress['value'] = 100
        
        button0.config(state='normal')
        button1.config(state='normal')

#redundant files deleted in main menu script

def executeInThread(GNCDir, InFileName, WorkDir, OutFileName):
    button0.config(state='disabled')
    button1.config(state='disabled')
    thread = Thread(target = execute, args = (GNCDir, InFileName, WorkDir, OutFileName))
    thread.start()



# for command=doNothing
def doNothing():
   text="Do nothing button"
   return


# for command=clickthumbn
def clickthumbn():
   novi = Toplevel(app)
   novi.title ('Example of visualized MSG FIRC image (in ILWIS)')
   novi.iconbitmap(gnc_path +r'/pics/gnc.ico')
   canvas = Canvas(novi, width = 400, height = 324)
   canvas.pack(expand = YES, fill = BOTH)
   gif1 = PhotoImage(file = gnc_path +r'/pics/MPEF_MSG0_FIRC.gif')
   canvas.create_image(0, 0,image = gif1, anchor = NW)
   canvas.gif1 = gif1

# for command=clickAbout
def clickAbout(): 
   filewin = Toplevel(app)
   filewin.title ('About FIRC')
   filewin.iconbitmap(gnc_path +r'/pics/gnc.ico')
   filewin.geometry("575x340")
   msg = Message(filewin, text="""MPEF MSG FIRC background:

The active fire monitoring product is a fire detection product indicating the presence of fire within a pixel. The underlying concept of the algorithm takes advantage of the fact that SEVIRI channel IR3.9 is very sensitive to hot spots which are caused by fires. The algorithm distinguishes between potential fire and active fire.

File name convertion: W_XX-EUMETSAT-Darmstadt,SING+LEV+SAT,MET<no>+FIRC_C_EUMG_<date>00_3.txt
Number of segments: 1 body segment
Temporal resolution: Every 15 minutes, starting from 00:00 UTC
Initial file format: text format

Data is provided throught EUMETCast reception. For Legal Constraints check the 'Product Navigator' at EUMETSAT available at http://navigator.eumetsat.int
""")
   msg.pack()


#main()
#automatically setting of path when running this script from main menu - uncomment to make active   
gnc_path = os.environ["gnc_popup"]

#check path
print (gnc_path)
app = Tk()
app.title("MPEF FIRC import routine")
app.iconbitmap(gnc_path +r'/pics/gnc.ico')

w = 650 # width for the Tk app
h = 210 # height for the Tk app

app.geometry('%dx%d' % (w, h))
app.resizable(0,0)

labelText1 = StringVar()
labelText1.set ("""MPEF FIRC import routine 
Typical filename: W_XX-EUMETSAT-Darmstadt,SING+LEV+SAT,MET<no>+FIRC_C_EUMG_<date>00_3.txt""")

label1 = Label(app, textvariable=labelText1, anchor='w', justify = LEFT)
label1.pack(side = LEFT)
label1.place(x = 10, y = 5, width=650, height=35)

L1 = Label(app, text="Input Directory:", anchor='w')
L1.pack(side = LEFT)
L1.place(x = 10, y = 50, width=150, height=25)

inputDir = StringVar()
E1 = Entry(app, textvariable=inputDir, bd =2)
E1.pack()
E1.place(x = 165, y = 50, width=445, height=25)

button_dirin = Button(app, text="....", width=2, command = lambda: inputDir.set(askdirectory(initialdir = inputDir.get())))
button_dirin.pack()
button_dirin.place(x = 615, y = 49)

L2 = Label(app, text="Time Stamp (in UTC-time):", anchor='w')
L2.pack(side = LEFT)
L2.place(x = 10, y = 80, width=150, height=25)

inputFile = StringVar()
E2 = Entry(app, textvariable=inputFile, bd =2)
E2.pack()
E2.place(x = 165, y = 80, width=445, height=25)

#button_filein = Button(app, text="....", width=2, command = lambda: inputFile.set(askopenfilename(initialdir = inputDir.get()).split('/')[-1]))
#button_filein.pack()
#button_filein.place(x = 615, y = 79)

L3 = Label(app, text="Output Directory:", anchor='w')
L3.pack(side = LEFT)
L3.place(x = 10, y = 110, width=150, height=25)

outputDir = StringVar()
E3 = Entry(app, textvariable=outputDir, bd =2)
E3.pack()
E3.place(x = 165, y = 110, width=445, height=25)

button_dirout = Button(app, text="....", width=2, command = lambda: outputDir.set(askdirectory(initialdir = outputDir.get())))
button_dirout.pack()
button_dirout.place(x = 615, y = 109) 

L4 = Label(app, text="Output Filename:", anchor='w')
L4.pack(side = LEFT)
L4.place(x = 10, y = 140, width=150, height=25)

outputFile = StringVar()
E4 = Entry(app, textvariable=outputFile, bd =2)
E4.pack()
E4.place(x = 165, y = 140, width=445, height=25)

button0 = Button(app, text="Quit", width=15, command=app.destroy)
button0.pack()
button0.place(x = 525, y = 180)

button1 = Button(app, text="Execute", width=15, command=lambda: executeInThread(inputDir.get(), inputFile.get(), outputDir.get(), outputFile.get()))
button1.pack()
button1.place(x = 405, y = 180)

button2 = Button(app, text="About FIRC", width=15, command=clickAbout)
button2.pack()
button2.place(x = 285, y = 180)

button3 = Button(app, text="Thumbnail", width=15, command=clickthumbn)
button3.pack()
button3.place(x = 165, y = 180)


style = Style()
style.theme_use('clam')
style.configure('blue.Horizontal.TProgressbar', foreground='blue', background='blue')

progress = Progressbar(app, style='blue.Horizontal.TProgressbar', orient=HORIZONTAL, length=100, mode='determinate')
progress.pack()
progress.place(x = 10, y = 180)


app.mainloop()

print("inputFile=" + inputFile.get())
print("outputDir=" + outputDir.get())
print("outputFile=" + outputFile.get())



